using System;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.ComponentModel;
using System.Drawing;
using System.Web.UI.HtmlControls;
using System.Web.UI.Design;
using System.ComponentModel.Design;


namespace DTPicker
{
	/// <summary>
	/// Summary description for WebCustomControl1.
	/// </summary>
	[DefaultProperty("Text"),
		ToolboxData("<{0}:DateTimePicker runat=server></{0}:DateTimePicker>")]
	[
		Designer("DTPicker.MyDesigner")
	]
	public class DateTimePicker : System.Web.UI.WebControls.WebControl,INamingContainer
	{
		
		private TextBox dArea=new TextBox();
		private Calendar cal=new Calendar();
		
		public DateTimePicker()
		{
			
			visibility=false;
			SelectedDate="1/1/1";
			FormatType="SHORT";
			
		}



		private bool visibility;
		
		
		public string SelectedDate
		{
			get
			{
				return (string)ViewState["selecteddate"];
			}
			set
			{

				ViewState["selecteddate"]=value;


			}
		}

		public string FormatType
		{
			get
			{
				return (string)ViewState["format"];

			}
			set
			{
				string val=(string)value;
				
				ViewState["format"]=val.ToUpper();

			}
		}

		



		protected void month_changed(object sender,MonthChangedEventArgs e)
		{

			visibility=true;
			
			
		}

		protected void date_changed(object sender,System.EventArgs e)
		{
			visibility=false;
			SelectedDate=cal.SelectedDate.ToShortDateString();
			

		}

		protected override void CreateChildControls()
		{
			
			
			cal.VisibleMonthChanged +=new MonthChangedEventHandler(month_changed);
			cal.SelectionChanged +=new System.EventHandler(date_changed);
            			
			Controls.Add(dArea);
			Controls.Add(cal);
			base.CreateChildControls();
			
		}

		

		/// <summary>
		/// Render this control to the output parameter specified.
		/// </summary>
		/// <param name="output"> The HTML writer to write out to </param>
		protected override void Render(HtmlTextWriter output)
		{
			if(Visible)
			{
				dArea.Width=this.Width;
				dArea.Height=new Unit("20px");
			

			
			
				//Display properties of Calendar Control
				cal.BackColor=Color.White;
				cal.BorderColor=Color.Red;
				cal.BorderStyle=BorderStyle.Solid;
				cal.BorderWidth=new Unit("4px");
				cal.DayHeaderStyle.BackColor=Color.White;
				cal.DayHeaderStyle.BorderColor=Color.Blue;
				cal.DayHeaderStyle.ForeColor=Color.BlueViolet;
				cal.DayNameFormat=DayNameFormat.Short;
				cal.Font.Size=FontUnit.Smaller;
				cal.ForeColor=Color.Black;
				cal.Height=new Unit("169px");
				cal.NextPrevFormat=NextPrevFormat.CustomText;
				cal.NextMonthText="&gt;";
				cal.PrevMonthText="&lt;";
				cal.NextPrevStyle.BackColor=Color.Silver;
				cal.NextPrevStyle.ForeColor=Color.Black;
				cal.NextPrevStyle.HorizontalAlign=HorizontalAlign.Center;
				cal.NextPrevStyle.VerticalAlign=VerticalAlign.Middle;
				cal.OtherMonthDayStyle.ForeColor=Color.Silver;
				cal.SelectedDayStyle.BackColor=Color.Black;
				cal.SelectedDayStyle.BorderColor=Color.Red;
				cal.SelectedDayStyle.BorderStyle=BorderStyle.Solid;
				cal.SelectedDayStyle.BorderWidth=new Unit("4px");
				cal.SelectedDayStyle.ForeColor=Color.White;
				cal.Width=new Unit("189px");
				cal.TitleStyle.BackColor=Color.Navy;
				cal.TitleStyle.ForeColor=Color.White;
				cal.TitleStyle.Font.Size=FontUnit.XSmall;
				cal.TitleStyle.Font.Bold=true;
				cal.TodayDayStyle.BackColor=Color.White;
				cal.TodayDayStyle.BorderColor=Color.Red;
				cal.TodayDayStyle.BorderStyle=BorderStyle.Solid;
				cal.TodayDayStyle.BorderWidth=new Unit("4px");
				cal.TodayDayStyle.ForeColor=Color.Black;
				
				//Check for the format of the "SelectedDate Property".The format 
				//should be mm/dd/yy.If the format is wrong or the value of SelectedDate
				//property is the default 1\1\1,the Selected Date becomes TodaysDate
			
				string delim="/";
				string[] cons=SelectedDate.Split(delim.ToCharArray());
				int year=1;
				int month=1;
				int day=1;

				if(cons.Length==3)
				{
				
					year=Convert.ToInt32(cons[2]);
					month=Convert.ToInt32(cons[1]);
					day=Convert.ToInt32(cons[0]);
				}
				
				
				if(year>1 || month>1 || day>1)
				{
					
					if(!visibility)
					{

						cal.TodaysDate=new DateTime(year,day,month);
					}
					cal.SelectedDate=new DateTime(year,day,month);
			
					
					if(FormatType=="SHORT")
			
						dArea.Text=cal.SelectedDate.ToShortDateString();
					else
					{
						dArea.Text=cal.SelectedDate.ToLongDateString();

					}
				}
					
				else
				{
					cal.SelectedDate=cal.TodaysDate;
					SelectedDate=cal.SelectedDate.ToShortDateString();
					if(FormatType=="SHORT")
						dArea.Text=cal.TodaysDate.ToShortDateString();
					else
					{
						dArea.Text=cal.TodaysDate.ToLongDateString();

					}
					
				
				}

				string uniqueID=this.UniqueID;//uniqueID generated for control
				string spanID="main"+uniqueID;//ID of the span HTML control 
				string btnID=uniqueID+"btn";//ID of the button
				string tdID=uniqueID+"td";//ID of the TD housing the Calendar
				string hidID=uniqueID+"_a1";//ID of the input hidden control;helps in capturing BackButton


				//controls the display property of Calendar 
				//The Calendar is hiding when the page is first loaded or when date changed event occurs
				//The Calendar is visible when month change event occurs
				//This variable controls the display style
				string display;

				string onloadfn=uniqueID+"setfocusonload()";//this fn gets executed when IFRAME loads
				string togfn=uniqueID+"setfocusonclick()";//function executed on the onclicck eventof button...display calendar if invisible
                string onblurfn=uniqueID+"hideCal()";//when a TD containing the Calendar loses focus...The calendar is made invisible
				string onfocusfn=uniqueID+"showCal()";//when TD gets focus calendar is made visible
				string donothing=uniqueID+"donothing()";
				string onmouseoverfn=uniqueID+"getover()";
				string onmouseoutfn=uniqueID+"getout()";

				//render the dummy IFRAME tag
				output.WriteLine("<IFRAME  height='0px' width='0px' onload='"+onloadfn+"'STYLE='visibility:hidden'>");
				output.WriteLine("</IFRAME>");
		
				//render hidden control with value according to visibility required
				//and the display property to be used for calendar
				if(visibility==false)
				{

					output.WriteLine("<INPUT ID=\""+hidID+"\" type='text'  VALUE=\"0\" STYLE=\"visibility:hidden\">");
					display="none";
				
				}
				else
				{
					output.WriteLine("<INPUT ID=\""+hidID+"\" VALUE=\"1\" STYLE=\"visibility:hidden\">");
					display="";
				
				}

				

				//start outputting the script
                output.WriteLine("<script>");

				//'over' keeps track of the position of mouse...to check if button was clicked
				output.WriteLine("over=0;");

				//This function is executed on the load of IFRAME
				//If the calendar is visible when page is loaded
				//we simply give Calendar focus and set its z-Index property
				//z-Index property controls 3D effect
				//The function checks value of hidden control to see if Calendar 
				//is visible or otherwise.
				output.WriteLine("function "+onloadfn);
				output.WriteLine("{");
				output.WriteLine("if(document.all('"+hidID+"').value==1)");
				output.WriteLine("{");
				output.WriteLine("document.all('"+tdID+"').focus()");
				output.WriteLine("document.all('"+spanID+"')"+".style.zIndex=120;");
				output.WriteLine("}");
				output.WriteLine("}");

				//This function is called when the button is clicked.This simply gives focus
				//to the TD and also sets the z-Index property.The above function works
				//when calendar is visible..this one works when it is invisible.
				//This fn sets the value of hidden control to 1...
				//setting this value to 1 gives the onload function above to set
				//the z-Index property even if we use back button.This is because browsers
				//caches the value of "<input>" controls of previous pages.Back Button of
				//browser can become enabled when we change months
                output.WriteLine("function "+togfn);
				output.WriteLine("{");
				output.WriteLine("if("+uniqueID+".style.display=='none')");
				output.WriteLine("{");
				output.WriteLine("document.all('"+tdID+"').focus()");
				output.WriteLine("document.all('"+spanID+"')"+".style.zIndex=120;");
				output.WriteLine("document.all('"+hidID+"').value=1;");
				output.WriteLine("}");
				output.WriteLine("}");


				//The TD on losing focus hides the Calendar within it
				//But if the lost focus occured due to the button click
				//(indicated by over==1)the Cal won't get invisible sine
				//the button click will be called immediately after this onblur event
				//which will again cause it to be displayed...The only thing that we can 
				//do is somehow disable the click for once..This is 
				//done by assigning 'donothing' fn to it..which doesn't do anything
				//with the calendar..it simply restores the eventhandler for button onclick
				//so everything is back to normal.
				output.WriteLine("function "+onblurfn);
				output.WriteLine("{");
				output.WriteLine("document.all('"+tdID+"').childNodes(0).style.display='none';");
				output.WriteLine("if (over==1)");
				output.WriteLine("document.all('"+btnID+"').onclick="+uniqueID+"donothing;");
				output.WriteLine("}");

				//When TD gets focus it simply makes the Calendar within it visible
				output.WriteLine("function "+onfocusfn);
				output.WriteLine("{");
				output.WriteLine("document.all('"+tdID+"').childNodes(0).style.display='';");
				output.WriteLine("}");

				//As explained below this function simply restores the onclick handler
				output.WriteLine("function "+donothing);
				output.WriteLine("{");
				output.WriteLine("document.all('"+btnID+"').onclick="+uniqueID+"toggleCal;");
				output.WriteLine("}");

				//Both the functions below help in checking if the onblur
				//event of TD was the raised due to the button
				output.WriteLine("function "+onmouseoverfn);
				output.WriteLine("{");
				output.WriteLine("over=1;");
				output.WriteLine("}");


				output.WriteLine("function "+onmouseoutfn);
				output.WriteLine("{");
				output.WriteLine("over=0;");
				output.WriteLine("}");

				output.WriteLine("</script>");

				//Finished rendering the script portion

                //Start rendering the Controls
                //The Table which contains both TextBox and the button The syle attribute
				//which is set by designer is applied,so that the absolute
				//positioning of DateTimePicker is possible
				output.Write("<table  cellspacing=\"0\" cellpadding=\"0\" style=\""+this.Attributes["style"]+"\">");	
				output.Write("<tr>");
				output.Write("<td>");

				//render the textBox server control by using the RenderControl method
				dArea.RenderControl(output);

				//render the button tag..we need no server buttons..but normal HTML buttons
				output.Write("<button  id='"+btnID+"' style='POSITION:absolute;height:22px;font-family:webdings;font-size:XX-Small;' onclick=\""+togfn+"\" onmouseover="+onmouseoverfn+" onmouseout="+onmouseoutfn+">");
				output.Write("6");
				output.WriteLine("</button>");
				
				output.Write("</td>");
				output.Write("</tr>");
				output.WriteLine("</table>");

				//The style attribute as provided by designer is not possible for the span tag
				//since it should come just below the textbox..this is done by incrementing 
				//the style attribute "TOP" by the height of the textBox
				string style=this.Attributes["style"];
				delim=";";
				string[] con=style.Split(delim.ToCharArray());

				for(int i=0;i<con.GetLength(0);i++)
				{
					if(con[i].IndexOf("TOP")!=-1)
					{
						string delimiter=":";
						string[] subcon=con[i].Split(delimiter.ToCharArray());
						subcon[1]=subcon[1].Remove(subcon[1].IndexOf("px"),2);
						int oTop=Convert.ToInt32(subcon[1]);
						int newTop=oTop+Convert.ToInt32(dArea.Height.Value);
						con[i]=subcon[0]+":"+newTop.ToString()+"px";
					}
				}
				style="";
				for(int i=0;i<con.GetLength(0);i++)
				{
					style+=con[i]+";";	
				}

				
				//The <SPAN> tag is needed since only some tags provide DHTML
				//support for changing z-Index.SPAN is one of them
				output.Write("<SPAN ID=\""+spanID+"\""+ "style=\""+style+"\">");
				output.Write("<table>");
				output.Write("<tr>");
				//The TD which houses the calendar and which suitably hides and dispalys the
				//calendar control which is its child.
				output.Write("<td  id=\""+tdID+"\" onblur=\""+onblurfn+"\""+"onfocus=\""+onfocusfn +"\">");
				output.Write("<table ID=\""+uniqueID+"\" "+"style=DISPLAY:"+display+" >");	
				output.Write("<tr>");
				output.Write("<td>");

				//render the calendar control
                cal.RenderControl(output);

			
				output.Write("</td>");
			
				output.Write("</tr>");

				output.Write("</table>");

				output.Write("</td>");
				output.Write("</tr>");
				output.Write("</table>");
				output.WriteLine("</SPAN>");
			}
			
					

		}
	}
	public class MyDesigner:ControlDesigner
	{
		
				string width;

		public override bool AllowResize
		{
			get
			{
				return true;
			}
		}
		public  override string GetDesignTimeHtml()
		{

				string designTimeHtml;
			    
				DateTimePicker controlDesigned=(DateTimePicker)this.Component;
				string dateDesignTime=controlDesigned.SelectedDate;
				string format=controlDesigned.FormatType;
				Calendar cal=new Calendar();
					
			string delim="/";
			string[] cons=dateDesignTime.Split(delim.ToCharArray());
			int year=1;
			int month=1;
			int day=1;

			if(cons.Length==3)
			{
				
				year=Convert.ToInt32(cons[2]);
				month=Convert.ToInt32(cons[1]);
				day=Convert.ToInt32(cons[0]);
			}
				
				
			if(year>1 || month>1 || day>1)
			{
								
				cal.SelectedDate=new DateTime(year,day,month);
										
				if(format=="SHORT")
					dateDesignTime=cal.SelectedDate.ToShortDateString();
				else
				{
					dateDesignTime=cal.SelectedDate.ToLongDateString();

				}
			}
				
			else
			{
				dateDesignTime="The date given is in wrong format";
								
			}

				width=this.Behavior.GetAttribute("Width",true).ToString();
				designTimeHtml="<input  type=\"text\"  style=\"width:"+width+"\" value=\""+dateDesignTime+"\">"+"<button style='font-family:webdings;font-size:XX-Small;'>6</button>";
						
				return designTimeHtml;
		
		}
}

	
}
